/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.3 Evaluation
Automatic Program Generator
 Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : RS-232 Stepper Motor Controller
Version : 1.0.0.0
Date    : 09.05.2007
Author  : Khurtin I.S.
Company : home
Comments: 
Freeware, for evaluation and non-commercial use only


Chip type           : ATmega16
Program type        : Application
Clock frequency     : 1,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega16.h>

// Standard Input/Output functions
#include <stdio.h>

#define UPE  2
#define OVR  3
#define FE   4
#define UDRE 5
#define RXC  7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)


// Declare your global variables here
bit step = 0b0; //,    B.0
char steppers = 0x00; //,   
const char stepDecrement = 1; //, , 
//        
//   

/*,   1  steppers == 0x00
   interrupt [TIM1_OVF] void timer1_ovf_isr(void).
     USART    
 ,        */
bit doneFlag = 0b0; 


void putCharToUSART(char ch) 
{
//    USART
while ( !(UCSRA & (1<<UDRE)) ); //    USART
//     USART  
UDR = ch;
}
 

interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
// Timer 1 overflow interrupt service routine
// Reinitialize Timer 1 value
TCNT1H=0xCF; //  16-   ,
TCNT1L=0x2B; // 0xFFFF-0x30D4=0xCF2B
// Place your code here
if (steppers > 0x00)
   {
   step = ~step;   //   0  ,
   PORTB.0 = step; //       25 
                   //  1/2    
   }
if ((steppers == 0x00) && (doneFlag == 0b0))
   {
   doneFlag = 0b1; //  
   putCharToUSART('D'); //    USART  "Done"
   putCharToUSART('o');
   putCharToUSART('n');
   putCharToUSART('e');
   putCharToUSART(' ');
   }
}


interrupt [EXT_INT2] void int2(void)
{
//   PORTB.2 INT2 -   
// ,     1 
steppers = steppers - stepDecrement; //  
}


// USART Receiver interrupt service routine
interrupt [USART_RXC] void usart_rx_isr(void)
{
//     USART
char status, data;
bit direction = 0b1; //  

status = UCSRA; //   UCSRA
data = UDR; //  

if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0) //    
  {
  switch (data)//   
     {
     case 'r':
        direction = 0b1; //  - 
     break;
     
     case 'l':
        direction = 0b0; //  - 
     break;
     
     default: 
        steppers = data; //    , 
                         //,    -  
        step = 0b0; //     
     }
     
  }
PORTB.1 = direction; //     PORTB.1
}


void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=Out Func0=Out 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=0 State0=0 
PORTB=0x00;
DDRB=0x03;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x01;
TCNT1H=0x9E;
TCNT1L=0x57;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x04;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud rate: 9600
UCSRA=0x00;
UCSRB=0x18;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x06;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;   

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: On
// INT2 Mode: Rising Edge
GICR|=0x20;
MCUCR=0x00;
MCUCSR=0x40;
GIFR=0x20;

// Global enable interrupts
#asm("sei")

while (1)
      {
      // Place your code here

      };
}
